/*								*
	proxcfg.h						*
*/

#define SUCCESS 0
#define FAILURE 0xFF
#define CLEAR 0
#define SET 0xFF
#define FLAGSET 0x01
#define COLOR 1

struct sockaddr thesock;
/* there is an interesting subtlety here.  We don't know 
   how SIOCDEVPRIVATE is going to be used if we accidentally
   use proxcfg on a non-Proxim driver.  Most drivers seem
   to use it to return the phy address.  you see something
   like 'data[0]=(int)phy'.  Therefore, I make 'cmd' an
   int so that this is safe.  */
struct Prox_ioctl_info {
	int cmd;
	unsigned char *data;
};
struct MastersList
{
        unsigned_8      ChSubChannel;
        unsigned_8      Name[11];
        unsigned_8      Address[6];
};
char *nodetypes[]={"Station", "Alternate Master", "Master"};
char *roamtypes[]={"slow", "normal", "fast"};
char *macconfigtypes[]={"very light", "light", "normal"};
char *hoptypes[]={"100 ms", "200 ms", "400 ms", "20 ms"};
char *card_types[]={
	"Proxim Wireless FH ISA Card",
	"Proxim 630x mini-ISA Card",
	"Proxim 6330 micro design-in Card",
	"Proxim Wireless FH PC Card",
	"Proxim Wireless FH PnP-ISA Card",
	"Proxim Wireless FH PCI Card",
	"Proxim Wireless FH USB Card",
	"Proxim 633x micro jr Card"
};
char *CardConfig[]={
	"RangeLAN2",
	"Symphony (OpenAir)",
	"HomeRF",
	"undefined 3",
	"CE Card (OpenAir)",
	"undefined 5",
	"undefined 6",
	"undefined 7",
	"RangeLAN2",
	"Symphony (OpenAir)",
	"RangeLAN2",
	"CE Card (OpenAir)",
	"undefined 8",
	"undefined 9",
	"undefined 10",
	"undefined 11"
};

/* IOCTL's called via SIOCDEVPRIVATE */
enum {
	CHECK_SIG, SET_LLDRESET,
	SET_NODETYPE, GET_NODETYPE,
	SET_DOMAIN, GET_DOMAIN,
	SET_SECID, SET_SYNC2_SECID,
	SET_NWID, SET_SYNC2_NWID,
	SET_SOFTSECID, SET_SOFTNWID,
	SET_CHANNEL, GET_CHANNEL,
	SET_SUBCHANNEL, GET_SUBCHANNEL,
	SET_MASTERNAME, GET_MASTERNAME,
        SET_ROAM_CONFIG, GET_ROAM_CONFIG,
        SET_MAC_OPT, GET_MAC_OPT,
        SET_DEBUG, GET_DEBUG,
        SET_DEBUG_COLOR, GET_DEBUG_COLOR,
        SET_PEER_TO_PEER, GET_PEER_TO_PEER,
        SET_ITO, GET_ITO,
	SET_DISABLE_ROAM, GET_DISABLE_ROAM,
	GET_SYNCSTATE,
	GET_MSTASYNCNAME,
	GET_MSTAADDR,
	GET_MSTASYNCCHANNEL,
	GET_MSTASYNCSUBCHANNEL,
	GET_ROMVERSION,
	SET_ADDR, GET_ADDR,
	GET_CC, GET_DYNCC,
	GET_DRIVERVERSION,
	SET_NODE_OVERRIDE,
	SET_HOP_PERIOD, GET_HOP_PERIOD,
	SET_BFREQ, GET_BFREQ,
	SET_BRIDGING, GET_BRIDGING,
	GET_PROTO_MODE,
	GET_CARD_NAME,
	GET_CARD_CONFIG,
	SEND_PROX_PING, GET_PROX_PING,
	START_AP_SEARCH, STOP_AP_SEARCH, AP_LIST,
	TEACH_MODE, LEARN_MODE,
	GET_MSTANWID, GET_SECID
};

/* above SIOCDEVPRIVATE used by wireless ext to hook commands */
#define SIOCSIPSUBC	SIOCDEVPRIVATE + 1	/* Set subchannel */
#define SIOCGIPSUBC	SIOCDEVPRIVATE + 2	/* Get subchannel */
#define SIOCSIPSTNT	SIOCDEVPRIVATE + 3	/* Set station type */
#define SIOCGIPSTNT	SIOCDEVPRIVATE + 4	/* Get station type */
#define SIOCSIPMNAM	SIOCDEVPRIVATE + 5	/* Set master name */
#define SIOCGIPMNAM	SIOCDEVPRIVATE + 6	/* Get master name */
#define SIOCSIPSECID	SIOCDEVPRIVATE + 7	/* Set security ID */
#define SIOCGIPSECID	SIOCDEVPRIVATE + 8	/* Get security ID */

#define PROX_SIG "PrOxIm"

extern struct NodeEntry NodeTable[];
extern unsigned_8 MRUNodeEntry;
extern unsigned_8 LLDSyncState;
extern unsigned_8 LLDMSTASyncChannel;
extern unsigned_8 LLDMSTASyncSubChannel;
extern unsigned_8 LLDDomain;
extern unsigned_8 LLDNodeType;
extern unsigned_8 LLDMSTASyncName[];
extern unsigned_8 LLDMSTAName[];
extern unsigned_8 LLDChannel;
extern unsigned_8 LLDSubChannel;
extern unsigned_8 LLDSecurityID[];
extern unsigned_8 LLDNeedReset;
extern unsigned_8 PacketizePktBuf[];
extern unsigned_8 PacketSeqNum;
extern unsigned_8 LLDRoamingFlag;
extern unsigned_8 LLDBridgeFlag;

